/* GeoStats - IRC Statistical Services
** Copyright (c) 1999 Jonathan George
**  E-Mail: net@lite.net
*
** GeoStats CVS Identification
** $Id: sock.c,v 1.18 2001/06/14 02:29:49 jroes Exp $
*/

#include "stats.h"
#include "struct.h"
#include "proto.h"

fd_set readfds, nullfds;

/* Initiate the connection to the server, returns the FD */
int ConnectTo(char *host, int port)
{
	struct hostent *hp;
	struct sockaddr_in sa;
	struct in_addr * in;
	int s;

	if ((hp = gethostbyname (host)) == NULL) {
		log("Cannot gethostbyname(%s)", host);
		return (-1);
	}

	if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		log("Cannot create socket()");
		return (-1);
	}

        if (IsVHost()) {
                bzero((char *) &sa, sizeof(sa));
                sa.sin_family = AF_INET;
                if ((hp = gethostbyname (settings.vhost)) == NULL) {
			log("Unable to gethostbyname(%s)", settings.vhost);
                        return (-1);
                }
                in = (struct in_addr *) (hp->h_addr_list[0]);
                sa.sin_addr.s_addr = in->s_addr;
                sa.sin_port = 0;
                if (bind(s, (struct sockaddr *) &sa, sizeof(sa)) < 0) {
                        close(s);
			log("Unable to bind to VHOST %s", settings.vhost);
                        return (-1);
                }
        }

	bzero((void *) &sa, sizeof(sa));
	sa.sin_family = AF_INET;
	sa.sin_port = htons (port);
    bcopy(hp->h_addr, (char *) &sa.sin_addr, hp->h_length);

	if (connect (s, (struct sockaddr *) &sa, sizeof (sa)) < 0) {
		close (s);
		log("Cannot connect()");
		return (-1);
	}

	if (IsDebug()) {
		log("Connected to server(%s) port(%d)", host, port);
	}
	return s;
}

/* Here is where it all happens, get a line from the server
** and send it off to the parse function.  Also this is where
** chk, the timer function, is called.  
*/
void read_loop()
{
	int i, j, SelectResult;
	struct timeval TimeOut;
	char c;
	static char buf[BUFSIZE];

	while (1) {
		memset(buf, '\0', BUFSIZE);
		chk();
		FD_ZERO(&readfds);
		TimeOut.tv_sec = 500;
		TimeOut.tv_usec = 0L;
		FD_SET(servsock, &readfds);
	if ((SelectResult = select(FD_SETSIZE, &readfds, &nullfds, &nullfds,
			&TimeOut)) > 0) {
			for (j = 0; j < BUFSIZE; j++) {
				if (FD_ISSET(servsock, &readfds)) {
					i = read(servsock, &c, 1);
					if (i !=0) {
						if ((c == '\n') || (c == '\r')) {
							parse(buf);
							netinfo.inb += j;
							break;
						}
						buf[j] = c;
					} else
						return;
				} else
					break;
			}
		} else {
			if (SelectResult == 0) {
				log("Lost connection to server.");
				return;
			}
		}
	}
}

/* send a line of text to the server, Append the \n */
void sts(char *fmt,...)
{
	va_list ap;
	char buf[BUFSIZE];

	va_start (ap, fmt);
	vsnprintf (buf, BUFSIZE, fmt, ap);

	if (IsDebug()) {
		log("SENT: %s", buf);
	}
	strcat (buf, "\n");

	netinfo.outb += strlen(buf);

	if ((write (servsock, buf, strlen (buf))) == -1) {
		log("Write error.");
		exit(0);
	}

	va_end (ap);
}

